diff --git a/modules/LightRing_1-2/test/INA219/module_test_INA219.h b/modules/LightRing_1-2/test/INA219/module_test_INA219.h
new file mode 100644
index 0000000..08c3462
--- /dev/null
+++ b/modules/LightRing_1-2/test/INA219/module_test_INA219.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_INA219_H
+#define MODULE_TEST_INA219_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  int moduleTestIna219ShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* MODULE_TEST_INA219_H */
+
diff --git a/modules/LightRing_1-2/test/LED/module_test_LED.c b/modules/LightRing_1-2/test/LED/module_test_LED.c
new file mode 100644
index 0000000..cd97c0f
--- /dev/null
+++ b/modules/LightRing_1-2/test/LED/module_test_LED.c
@@ -0,0 +1,70 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_LED.h>
+#include <aos_test_LED.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_leddata_t _data = {
+  /* LED  */ &moduleLldStatusLed,
+};
+
+static AOS_TEST(_test, "LED", NULL, moduleTestLedShellCb, aosTestLedFunc, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestLedShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/modules/LightRing_1-2/test/LED/module_test_LED.h b/modules/LightRing_1-2/test/LED/module_test_LED.h
new file mode 100644
index 0000000..f9ae6c5
--- /dev/null
+++ b/modules/LightRing_1-2/test/LED/module_test_LED.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_LED_H
+#define MODULE_TEST_LED_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  int moduleTestLedShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* MODULE_TEST_LED_H */
+
diff --git a/modules/LightRing_1-2/test/MIC9404x/module_test_MIC9404x.c b/modules/LightRing_1-2/test/MIC9404x/module_test_MIC9404x.c
new file mode 100644
index 0000000..2425c6e
--- /dev/null
+++ b/modules/LightRing_1-2/test/MIC9404x/module_test_MIC9404x.c
@@ -0,0 +1,148 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_MIC9404x.h>
+#include <aos_test_MIC9404x.h>
+#include <string.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_mic9404data_t _data = {
+  /* driver */ NULL,
+};
+
+static AOS_TEST(_test, "MIC9404x", "power switch", moduleTestMic9404xShellCb, aosTestMic9404xFunc, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestMic9404xShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  enum {
+    UNKNOWN,
+    V18,
+    V33,
+// The 4.2V switch is disabled due to a hardware bug.
+//  V42,
+    V50,
+    VSYS,
+  } mic = UNKNOWN;
+
+  // evaluate argument
+  if (argc == 2) {
+    if (strcmp(argv[1], "1.8V") == 0) {
+      mic = V18;
+    } else if (strcmp(argv[1], "3.3V") == 0) {
+      mic = V33;
+// The 4.2V switch is disabled due to a hardware bug.
+//  } else if (strcmp(argv[1], "4.2V") == 0) {
+//    mic = V42;
+    } else if (strcmp(argv[1], "5.0V") == 0) {
+      mic = V50;
+    } else if (strcmp(argv[1], "VSYS") == 0) {
+      mic = VSYS;
+    }
+  }
+
+  // handle valid power switch
+  if (mic != UNKNOWN) {
+    aos_testresult_t res = {0, 0};
+
+    switch (mic) {
+      case V18:
+        _data.driver = &moduleLldPowerSwitchV18;
+        aosTestRun(stream, &_test, "1.8V");
+        _data.driver = NULL;
+        break;
+      case V33:
+        _data.driver = &moduleLldPowerSwitchV33;
+        aosTestRun(stream, &_test, "3.3V");
+        _data.driver = NULL;
+        break;
+// The 4.2V switch is disabled due to a hardware bug.
+//    case V42:
+//      _data.driver = &moduleLldPowerSwitchV42;
+//      aosTestRun(stream, &_test, "4.2V");
+//      _data.driver = NULL;
+//      break;
+      case V50:
+        _data.driver = &moduleLldPowerSwitchV50;
+        aosTestRun(stream, &_test, "5.0V");
+        _data.driver = NULL;
+        break;
+      case VSYS:
+        _data.driver = &moduleLldPowerSwitchVsys;
+        aosTestRun(stream, &_test, "VSYS");
+        _data.driver = NULL;
+        break;
+      default:
+        break;
+    }
+    if (result != NULL) {
+      *result = res;
+    }
+    return AOS_OK;
+  }
+  // handle invalid arguments
+  else {
+    // print help
+    chprintf(stream, "Usage: %s OPTION\n", argv[0]);
+    chprintf(stream, "Options:\n");
+    chprintf(stream, "  1.8V\n");
+    chprintf(stream, "    Test power switch for 1.8V supply.\n");
+    chprintf(stream, "  3.3V\n");
+    chprintf(stream, "    Test power switch for 3.3V supply.\n");
+// The 4.2V switch is disabled due to a hardware bug.
+//  chprintf(stream, "  4.2V\n");
+//  chprintf(stream, "    Test power switch for 4.2V supply.\n");
+    chprintf(stream, "  5.0V\n");
+    chprintf(stream, "    Test power switch for 5.0V supply.\n");
+    chprintf(stream, "  VSYS\n");
+    chprintf(stream, "    Test power switch for VSYS supply.\n");
+    if (result != NULL) {
+      result->passed = 0;
+      result->failed = 0;
+    }
+    return AOS_INVALIDARGUMENTS;
+  }
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/modules/LightRing_1-2/test/MIC9404x/module_test_MIC9404x.h b/modules/LightRing_1-2/test/MIC9404x/module_test_MIC9404x.h
new file mode 100644
index 0000000..cc676fd
--- /dev/null
+++ b/modules/LightRing_1-2/test/MIC9404x/module_test_MIC9404x.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_MIC9404x_H
+#define MODULE_TEST_MIC9404x_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  int moduleTestMic9404xShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* MODULE_TEST_MIC9404x_H */
+
diff --git a/modules/LightRing_1-2/test/TLC5947/module_test_TLC5947.c b/modules/LightRing_1-2/test/TLC5947/module_test_TLC5947.c
new file mode 100644
index 0000000..80730a8
--- /dev/null
+++ b/modules/LightRing_1-2/test/TLC5947/module_test_TLC5947.c
@@ -0,0 +1,70 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_TLC5947.h>
+#include <aos_test_TLC5947.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_tlc5947data_t _data = {
+  /* driver   */ &moduleLldLedPwm,
+};
+
+static AOS_TEST(_test, "TLC5947", "24 channel PWM LED driver", moduleTestTlc5947ShellCb, aosTestTlc5947Func, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestTlc5947ShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/modules/LightRing_1-2/test/TLC5947/module_test_TLC5947.h b/modules/LightRing_1-2/test/TLC5947/module_test_TLC5947.h
new file mode 100644
index 0000000..c56ba72
--- /dev/null
+++ b/modules/LightRing_1-2/test/TLC5947/module_test_TLC5947.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_TLC5947_H
+#define MODULE_TEST_TLC5947_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+   int moduleTestTlc5947ShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* MODULE_TEST_TLC5947_H */
+
diff --git a/modules/NUCLEO-F103RB/Makefile b/modules/NUCLEO-F103RB/Makefile
index 514af80..082d9fd 100644
--- a/modules/NUCLEO-F103RB/Makefile
+++ b/modules/NUCLEO-F103RB/Makefile
@@ -112,100 +112,55 @@ endif
 # Project, target, sources and paths                                           #
 #                                                                              #
 
-# Absolute path to the project
-PROJECT_PATH := $(abspath $(dir $(abspath $(lastword $(MAKEFILE_LIST)))))
+# Absolute path to the project.
+PROJECT_PATH := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))
 
-# Define project name here
-PROJECT := $(patsubst $(abspath $(dir $(abspath $(lastword $(MAKEFILE_LIST))))..)/%,%,$(PROJECT_PATH))
+# Project name.
+PROJECT := $(notdir $(PROJECT_PATH))
 
 # Target settings.
 MCU = cortex-m3
 
-# Imported source files and paths.
-include ../../kernel/kernel.mk
-CHIBIOS    := $(AMIROOS_KERNEL)
-CONFDIR    := .
+# Module specific paths and directories.
+MODULEDIR := .
+CONFDIR := $(MODULEDIR)
 ifeq ($(BUILDDIR),)
   BUILDDIR := $(PROJECT_PATH)/build
 endif
-DEPDIR     := $(dir $(BUILDDIR)).dep
-AMIROOS    := ../..
-# Licensing files.
-include $(CHIBIOS)/os/license/license.mk
-# Startup files.
+DEPDIR := $(dir $(BUILDDIR)).dep
+
+# Linker script.
+LDSCRIPT= STM32F103xB.ld
+
+# General AMiRo-OS files.
+include ../../amiroos.mk
+
+# Module specific ChibiOS files.
 include $(CHIBIOS)/os/common/startup/ARMCMx/compilers/GCC/mk/startup_stm32f1xx.mk
-# HAL-OSAL files (optional).
-include $(CHIBIOS)/os/hal/hal.mk
 include $(CHIBIOS)/os/hal/ports/STM32/STM32F1xx/platform.mk
-include $(CHIBIOS)/os/hal/osal/rt/osal.mk
-include $(CHIBIOS)/os/hal/lib/streams/streams.mk
-# RTOS files (optional).
-include $(CHIBIOS)/os/rt/rt.mk
 include $(CHIBIOS)/os/common/ports/ARMCMx/compilers/GCC/mk/port_v7m.mk
-# Auto-build files in ./source recursively.
-include $(CHIBIOS)/tools/mk/autobuild.mk
-# Other files (optional).
-include $(CHIBIOS)/test/lib/test.mk
-include $(CHIBIOS)/test/rt/rt_test.mk
-include $(CHIBIOS)/test/oslib/oslib_test.mk
-# AMiRo-BLT files
-include ../../bootloader/bootloader.mk
-# AMiRo-LLD files
-include ../../periphery-lld/periphery-lld.mk
-# AMiRo-OS files
-include ../modules.mk
-include $(AMIROOS)/core/core.mk
-include $(AMIROOS)/unittests/unittests.mk
-
-# Define linker script file here
-LDSCRIPT= STM32F103xB.ld
 
-# C sources that can be compiled in ARM or THUMB mode depending on the global
-# setting.
-CSRC = $(ALLCSRC) \
-       $(CHIBIOS)/os/various/syscalls.c \
-       $(CHIBIOS)/os/various/evtimer.c \
-       $(TESTSRC) \
-       board.c \
-       $(PERIPHERYLLDCSRC) \
-       $(UNITTESTSCSRC) \
-       $(AMIROOSCORECSRC) \
-       $(MODULESCSRC) \
-       module.c \
-       $(APPSCSRC)
-
-# C++ sources that can be compiled in ARM or THUMB mode depending on the global
-# setting.
-CPPSRC = $(ALLCPPSRC) \
-         $(CHIBIOS)/os/various/cpp_wrappers/syscalls_cpp.cpp \
-         $(AMIROOSCORECPPSRC) \
-         $(APPSCPPSRC)
-
-# List ASM source files here.
-ASMSRC = $(ALLASMSRC) \
-         $(APPSASMSRC)
-
-# List ASM with preprocessor source files here.
-ASMXSRC = $(ALLXASMSRC) \
-          $(APPSASMXSRC)
-
-# Inclusion directories.
-INCDIR = $(CONFDIR) \
-         $(ALLINC) \
-         $(TESTINC) \
-         $(CHIBIOS)/os/hal/lib/streams \
-         $(BOOTLOADERINC) \
-         $(PERIPHERYLLDINC) \
-         $(AMIROOS) \
-         $(UNITTESTSINC) \
-         $(AMIROOSCOREINC) \
-         $(MODULESINC) \
-         $(APPSINC)
-
-# Define C warning options here.
+# Periphery LLDs.
+AMIROOS_PERIPHERYLLD_INC += $(AMIROLLD)/drivers/LED/v1 \
+                            $(AMIROLLD)/drivers/button/v1
+#                            $(AMIROLLD)/drivers/DW1000/v1
+
+# Tests.
+AMIROOS_TEST_INC += $(AMIROOS_TEST_DIR)periphery-lld/button_v1 \
+                    $(AMIROOS_TEST_DIR)periphery-lld/LED_v1
+#                    $(AMIROOS_TEST_DIR)periphery-lld/DW1000_v1
+
+# Module specific inclusion directories
+MODULE_INC = $(MODULEDIR) \
+             $(wildcard $(MODULEDIR)/test/*)
+
+# Module specific C source files.
+MODULE_CSRC = $(wildcard $(MODULE_INC:%=%/*.[Cc]))
+
+# C warning options.
 CWARN = -Wall -Wextra -Wundef -Wstrict-prototypes
 
-# Define C++ warning options here.
+# C++ warning options.
 CPPWARN = -Wall -Wextra -Wundef
 
 #                                                                              #
diff --git a/modules/NUCLEO-F103RB/alldconf.h b/modules/NUCLEO-F103RB/alldconf.h
index 606722c..a1e4ea4 100644
--- a/modules/NUCLEO-F103RB/alldconf.h
+++ b/modules/NUCLEO-F103RB/alldconf.h
@@ -43,12 +43,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define AMIROLLD_CFG_TIME_SIZE                  32
 
-/**
- * @brief   Enable flag for the DW1000 UWB transmitter.
- * @note    Uncomment this if the device is attached.
- */
-//#define AMIROLLD_CFG_DW1000                     1
-
 #endif /* ALLDCONF_H */
 
 /** @} */
diff --git a/modules/NUCLEO-F103RB/aosconf.h b/modules/NUCLEO-F103RB/aosconf.h
index 6483502..0d7b9db 100644
--- a/modules/NUCLEO-F103RB/aosconf.h
+++ b/modules/NUCLEO-F103RB/aosconf.h
@@ -84,7 +84,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @note    Any mandatory events (e.g. for SSSP) are enabled implicitely despite this configuration.
  */
 #if !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK)
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    (MODULE_OS_IOEVENTFLAGS_DW1000_IRQn | MODULE_OS_IOEVENTFLAGS_USERBUTTON)
+  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    MODULE_OS_IOEVENTFLAGS_USERBUTTON
+//  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    (MODULE_OS_IOEVENTFLAGS_DW1000_IRQn | MODULE_OS_IOEVENTFLAGS_USERBUTTON)
 #else /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
   #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    OS_CFG_MAIN_LOOP_IOEVENT_MASK
 #endif /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
